您的位置:首页 > 其它

HDU-2639 Bone Collector II

2016-03-30 23:00 369 查看
Description

The title of this problem is familiar,isn't it?yeah,if you had took part in the "Rookie Cup" competition,you must have seem this title.If you haven't seen it before,it doesn't matter,I will give you a link:

Here is the link: http://acm.hdu.edu.cn/showproblem.php?pid=2602

Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum
.. to the K-th maximum.

If the total number of different values is less than K,just ouput 0.

Input

The first line contain a integer T , the number of cases.

Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value
of each bone. The third line contain N integers representing the volume of each bone.

Output

One integer per line representing the K-th maximum of the total value (this number will be less than 2 31).

Sample Input

3
5 10 2
1 2 3 4 5
5 4 3 2 1
5 10 12
1 2 3 4 5
5 4 3 2 1
5 10 16
1 2 3 4 5
5 4 3 2 1


Sample Output

12
2
0


思路:求第K大的最优值,最普通的01背包我们都只保存子问题唯一的最优值,现在则需要保存子问题的前K大的最优值,

假设在普通的01背包中,dp[i]即表示体积 i 的最优值(二维dp可优化成一维dp,详见背包九讲),dp[i][k]表示体积为 i 时的第K个最优值,那么一开始dp[i][1...k]均应初始化为0

01背包中有状态转移方程:dp[i]=max(dp[i],dp[i-v]+v),事实上就是从一个最优值衍生多一个"最优值"后,再在二者中选择最优的保留,其实此时可看做本题的k为1的情况.

所以求第K大,只需要每次保留前K个最优值,再衍生出K个“最优值”,从这2K个“最优值”中选出前K个不重复的最优值,反复如此即可。

可能表述不清,还望指出.....

AC代码(含注释):

#include<iostream>
#include<string.h>
using namespace std;

typedef long long LL;
#define min(a,b) (a>b?b:a)
#define max(a,b) (a>b?a:b)
#define init(a,num) memset(a,num,sizeof(a))

int a[1005],b[1005];
int dp[1005][35];

int main()
{
int t;
cin >> t;
while (t--)
{
int n, v, k;
cin >> n >> v >> k;
for (int i = 0; i < n; ++i)
{
cin >> b[i];
}
for (int i = 0; i < n; ++i)
{
cin >> a[i];
}
int d1[35],d2[35];
init(dp,0);
init(d1,0);
init(d2,0);
for (int j = 0; j < n; ++j)
{
for (int i = v; i >= a[j]; --i)
{
int l;
for(l=1;l<=k;++l)
{
d1[l]=dp[i][l];//上个子问题中保留的前K个最优值
d2[l]=dp[i-a[j]][l]+b[j];//由K个最优衍生出来的K个值
}
d1[l]=d2[l]=-1;
int pos,pos1,pos2;
pos=pos1=pos2=1;
while(pos<=k&&(d1[pos1]!=-1||d2[pos2]!=-1))//合二为一
{
if(d1[pos1]>d2[pos2])
{
dp[i][pos]=d1[pos1++];
}
else
{
dp[i][pos]=d2[pos2++];
}
if(dp[i][pos-1]!=dp[i][pos])pos++;//关键,去重
}
}
}
cout << dp[v][k] << endl;
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: